import java.util.ArrayList;
import java.util.Comparator;

/**
	This class is used to sort an ArrayList any type with a comparator of any type.
	The class uses an insertion sort in order to sort the ArrayList. The 
*/
public class InsertionSort {
	
	
/**
	This method is used to sort a passed array list using a passed comparator. The
	type of sort being used is insertion sort, which I made with help from Ryan and
	referencing the textbook (pg 104).
	@param list, the passed ArrayList that will be sorted
	@param comp, the passed Comparator that will be used to know how to sort the object
*/
	public static void sort(ArrayList<Object> list, Comparator<Object> comp)
	{
		int n = list.size() - 1;
		for(int i = 0; i < n; i++)
		{
			while((comp.compare(list.get(i), list.get(i+1))) > 0)
			{//Worked together with Ryan to figure this while loop out, he helped me A LOT! :D
				Object cur = list.get(i);
				Object temp = list.get(i+1);
				list.set(i, temp);
				list.set(i+1, cur);
				if (i > 0) 
				{
					i--;
				}
			}
		}
	}

}
